// -*- coding: utf-8 -*-
// * A Plone product to generate quiz. A quiz is a list of questions with the appropriate answer(s).
// * Content managers can build quiz easily and present users a report about the errors they did.
// * Copyright (C)2005 Ingeniweb
// * 
// * This program is free software; you can redistribute it and/or modify
// * it under the terms of the GNU General Public License as published by
// * the Free Software Foundation; either version 2 of the License, or
// * (at your option) any later version.
// *
// * This program is distributed in the hope that it will be useful,
// * but WITHOUT ANY WARRANTY; without even the implied warranty of
// * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// * GNU General Public License for more details.
// * 
// * You should have received a copy of the GNU General Public License
// * along with this program; see the file COPYING. If not, write to the
// * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


function removeFieldRow(node){

    // XXX replace with getParentElement
    row = node.parentNode.parentNode;
    row.parentNode.removeChild(row);

    return;
}


function handleKeyPress (e) {
    /* Dispatcher for handling the last row */

    // XXX: Generalize window.event for windows
    // Grab current node, replicate, remove listener, append
    var currnode = window.event ? window.event.srcElement : e.currentTarget;
    /* 
       XXX Should add/remove event listeners via JS, but IE has
       non-standard methods.  Not hard, but for now, just check 
       if we are the last row.  If not, bail.
    */

    var tbody = getParentElement(currnode, "TBODY");
    var tr = getParentElement(currnode, "TR");
    var rows = tbody.getElementsByTagName("TR");

    if (rows.length == (tr.rowIndex)) {
    // Add all the last row specific stuff here
    var newtr = tr.cloneNode(true);
    tr.parentNode.appendChild(newtr);

    // Turn on hidden "delete" image for current node
    var img = tr.getElementsByTagName("img")[0];
    img.style.display = "inline";
    } else {
    // Handle all other keypress entries, like cursor keys
    }

    return;
}


function getParentElement(currnode, tagname) {
    /* Recursive function to move up the tree to a certain parent */

    tagname = tagname.toUpperCase();
    var parent = currnode.parentNode;

    while (parent.tagName.toUpperCase() != tagname) {
    parent = parent.parentNode;
    // Next line is a safety belt
    if (parent.tagName.toUpperCase == "BODY") return null;
    }

    return parent;
}


function moveRowDown(node){
    row = getParentElement(node, "TR")
    nextRow = row.nextSibling
    var tbody = getParentElement(node, "TBODY");
    var rows = tbody.getElementsByTagName("TR");
    if (nextRow && (rows.length != (nextRow.rowIndex))){
        shiftRow(nextRow, row)
    }
}
function moveRowUp(node){
    row = getParentElement(node, "TR")
    previousRow = row.previousSibling
    if (previousRow){
    shiftRow(row, previousRow)
    }
}

function shiftRow(bottom, top){
    bottom.parentNode.insertBefore(bottom, top )   
}

